package com.sxtvs.open.api.odata.service.impl;

import com.sxtvs.open.api.odata.entity.WxgzhArticle;
import com.sxtvs.open.api.odata.entity.WxgzhGroup;
import com.sxtvs.open.api.odata.mapper.WxgzhArticleMapper;
import com.sxtvs.open.api.odata.service.IWxgzhArticleService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import jakarta.annotation.Resource;
import org.springframework.stereotype.Service;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author syj
 * @since 2024-03-14
 */
@Service
public class WxgzhArticleServiceImpl extends ServiceImpl<WxgzhArticleMapper, WxgzhArticle> implements IWxgzhArticleService {


    @Resource
    private WxgzhGroupServiceImpl wxgzhGroupService;

    public List<WxgzhArticle> hospitalArticleList(LocalDate start, LocalDate end) {
        return lambdaQuery().ge(WxgzhArticle::getPublished, start).le(WxgzhArticle::getPublished, end)
                .in(WxgzhArticle::getAuthor, wxgzhGroupService.hospitalList())
                .orderByDesc(WxgzhArticle::getBrowseTime).last("limit 20").list();
    }
}
