package com.sxtvs.open.api.review.dto;

import com.alibaba.fastjson.annotation.JSONField;
import com.sxtvs.open.api.review.entity.TypeDict;
import lombok.Data;
import lombok.NoArgsConstructor;

import java.util.List;

@NoArgsConstructor
@Data
public class ImgReviewResp {

    @JSONField(name = "taskId")
    private String taskId;
    @JSONField(name = "userName")
    private String userName;
    @JSONField(name = "source")
    private String source;
    @JSONField(name = "preset")
    private String preset;
    @JSONField(name = "results")
    private List<ResultsDTO> results;
    @JSONField(name = "status")
    private String status;
    @JSONField(name = "statusDesc")
    private String statusDesc;
    @JSONField(name = "description")
    private String description;
    @JSONField(name = "thumbnailMeta")
    private ThumbnailMetaDTO thumbnailMeta;
    @JSONField(name = "label")
    private String label;
    @JSONField(name = "labelDesc")
    private String labelDesc;

    @NoArgsConstructor
    @Data
    public static class ThumbnailMetaDTO {
        @JSONField(name = "widthInPixel")
        private Integer widthInPixel;
        @JSONField(name = "heightInPixel")
        private Integer heightInPixel;
    }

    @NoArgsConstructor
    @Data
    public static class ResultsDTO {
        @JSONField(name = "type")
        private String type;
        @JSONField(name = "typeDesc")
        private String typeDesc;
        @JSONField(name = "items")
        private List<ItemsDTO> items;

        @NoArgsConstructor
        @Data
        public static class ItemsDTO {
            @JSONField(name = "subType")
            private String subType;
            @JSONField(name = "subTypeDesc")
            private String subTypeDesc;
            @JSONField(name = "target")
            private String target;
            @JSONField(name = "confidence")
            private Double confidence;
            @JSONField(name = "label")
            private String label;
            @JSONField(name = "labelDesc")
            private String labelDesc;
            @JSONField(name = "evidence")
            private EvidenceDTO evidence;

            @NoArgsConstructor
            @Data
            public static class EvidenceDTO {
                @JSONField(name = "location")
                private LocationDTO location;

                @NoArgsConstructor
                @Data
                public static class LocationDTO {
                    @JSONField(name = "leftOffsetInPixel")
                    private Integer leftOffsetInPixel;
                    @JSONField(name = "topOffsetInPixel")
                    private Integer topOffsetInPixel;
                    @JSONField(name = "widthInPixel")
                    private Integer widthInPixel;
                    @JSONField(name = "heightInPixel")
                    private Integer heightInPixel;
                }
            }
        }
    }

    public void fill(){
        if (TypeDict.STATUS.containsKey(this.status)){
            this.statusDesc = TypeDict.STATUS.get(this.status);
        }
        if (TypeDict.LABEL.containsKey(this.label)){
            this.labelDesc = TypeDict.LABEL.get(this.label);
        }
        for(ResultsDTO resultsDTO : this.results){
            if (TypeDict.TYPE.containsKey(resultsDTO.type)){
                resultsDTO.typeDesc = TypeDict.TYPE.get(resultsDTO.type);
            }

            for(ResultsDTO.ItemsDTO itemsDTO : resultsDTO.items){
                if (TypeDict.LABEL.containsKey(itemsDTO.label)){
                    itemsDTO.labelDesc = TypeDict.LABEL.get(itemsDTO.label);
                }
                if (TypeDict.TYPE.containsKey(itemsDTO.subType)){
                    itemsDTO.subTypeDesc = TypeDict.TYPE.get(itemsDTO.subType);
                }
            }
        }
    }

}
